Subject: bug#29349: [Patch] Bug 29349: read_key_sequence is only partially recursive. This is a bug.

From: Eli Zaretskii <[email-masked]>
Date: Sun, 19 Nov 2017 20:02:23 +0200

> Date: Sun, 19 Nov 2017 17:45:22 +0000
> Cc: [email-masked]
> From: Alan Mackenzie <[email-masked]>
> 
> In the emacs-26 branch, in a Linux tty with GPM configured and working,
> type:
> 
>     C-h c  C-mouse-3 mouse-1 mouse-1
> 
> , without moving the mouse.  This will end up clicking on
> "emacs-tutorial".  The message printed in the message area is then:
> 
>     <C-down-mouse-3> <help-menu> <emacs-tutorial> (translated from
>     <mouse-1> <emacs-tutorial>) at that spot runs the command
>     help-with-tutorial
> 
> .  In the "translated from <mouse-1> <emacs-tutorial>", the first event,
> C-mouse-3 has been overwritten by mouse-1.  This mouse-1 is a mouse-click
> from the menu processing.  `describe-key-briefly' can then do nothing
> other than printing a spurious "translated from" message.
> 
> With the patch applied, the C-down-mouse-3 survives in the raw key
> buffer, enabling `describe-key-briefly' to do the Right Thing.  It does
> this by collecting the menu processing's mouse events in a separate
> buffer, then copying that buffer to the main one afterwards.

OK, but then (a) please install the patch on master, not on the
release branch, and (b) why do we need the followup patch -- with the
mouse-1 events injected into the sequence the "translation" looks
correct and even educational.

Thanks.